/* 
 * File:   DDS_629.c
 * Author: Joubert Attila
 *
 * Created on 2013. december 12., 14:45
 */

#include <stdio.h>
#include <stdlib.h>
#include <xc.h>

// CONFIG bitek
#pragma config FOSC = INTRCIO   // Oszcilltor kivlaszt bitek (INTOSC oszcilltor: I/O funkci a GP4/OSC2/CLKOUT lbon, I/O funkci a GP5/OSC1/CLKIN lbon)
#pragma config WDTE = OFF       // Watchdog Timer Enable bit (WDT tiltva)
#pragma config PWRTE = ON       // Power-Up Timer Enable bit (PWRT engedlyezve)
#pragma config MCLRE = OFF      // GP3/MCLR lb funkci kivlaszts (GP3/MCLR lb digitlis I/O, MCLR belsleg ktve a VDD-re)
#pragma config BOREN = OFF      // Brown-out Detect Enable bit (BOD tiltva)
#pragma config CP = OFF         // Code Protection bit (Program memria vdelem tiltva)
#pragma config CPD = OFF        // Data Code Protection bit (Adat memria vdelem tiltva)

#define _XTAL_FREQ = 4000000 // mert a PIC bels oszcilltort hasznljuk
#define FTWH = 968944636	// Az Excel tblval kiszmolt rtk (Frequency Tuning Word High)
#define FTWL = 14			// a 0Hz-hez tartoz rtk (Frequency Tuning Word Low)

//A DDS bektse a panelen sorrendben
//Vcc
#define W_CLK GPIObits.GP0 // a PIC 12F628 7. lbra ktend
#define FQ_UD GPIObits.GP1 // a PIC 12F628 6. lbra ktend
#define DATA GPIObits.GP2 // a PIC 12F628 5. lbra ktend
// a 4. lbat azrt hagytam ki, htha mgis kell MCLR funkci
#define RESET GPIObits.GP4 // a PIC 12F628 3. lbra ktend
#define YELLOW GPIObits.GP5 // a PIC 12F628 2. lbra ktend a mkdskor villog (srga) LED
//GND

// bitenknt kikld egy bjtot  sorosan (LSB elszr) a DDS (AD9850) serial DATA vonalra
void tfr_byte(unsigned char data){
  int i;
  for (i=0; i<8; i++){
	DATA= data & 0x01;
	data=data>>1;
    W_CLK=1; _delay(1);W_CLK=0;_delay(1);   //minden bit kikldse utn a CLK-ra felfut impulzust kld
  }
}

 // Az FTW kikldse a DDS-re
void sendFrequency(unsigned long freq1) {
  int b;
  unsigned char f;
 // double w;
 // freq1=FTW;

  for (b=0; b<4; b++) {
    f=freq1 & 0xFF;
    freq1=freq1>>8;
    tfr_byte(f);
  }
  tfr_byte(0x000);   // befejez vezrl bjt csupa 0 az AD9850 chip-nl
  FQ_UD=1; _delay(1);FQ_UD=0; _delay(1); // Ksz! Megjelenik a kvnt frekvencij jel a DDS kimenetn
}

void setup1(void) {
 
  TRISIO=0b001000;	// PIC lbak belltsa
  YELLOW=1;

  RESET=1;_delay(1); RESET=0;_delay(1);
  W_CLK=1;_delay(1); W_CLK=0;_delay(1);
  FQ_UD=1;_delay(1); FQ_UD=0;_delay(1);  // Ez az impulzus a soros md belltsnak utols mozzanata - az adatlapon 12. old. 10. bra
}



/*
 * 
 */
int main(int argc, char** argv) {
  unsigned long FTW;
  setup1();
  
  while(1){
    FTW=FTWH; //14,099MHz
    sendFrequency(FTW);  // Itt kell a kvnt frekit megadni     
	YELLOW=1;
	_delay(320000);
	YELLOW=0;
    FTW=FTWL; // 0Hz
    sendFrequency(FTW);  // Itt kell a kvnt frekit megadni
	_delay(160000);
  }
  return (EXIT_SUCCESS);
}

